﻿// JavaScript Document
/* 	Hussam Almoharb 2013
	hussam.am@gmail.com 	
	Gate
*/
var Gate = new Array();
Gate.type = {
	INPUT 	: 0,
	OUTPUT 	: 1,
	AND		: 2,
	OR		: 3,
	NOT		: 4,
	XOR		: 5,
	IMP		: 6
};

Gate.add = function(type,left,top,value,id)
{
	var img =  $($("svg[gateType="+type+"]")[0]).clone()[0];
				$(img).attr({
					x:left,
					y:top,
					"onmousedown":"move(this)",
					"class":"gate",
					//"onmouseup":"connectGate(this)",
					"id":(id?id:Gate.createID()), // if the gate doesn't have an id, create an id
					"onmouseover":"gateMouseover(this)",
					"onmouseout":"gateMouseout(this)",
					//"style": "fill: red; stroke: blue; stroke-width: 3"
					"type":type,
					"value":(value?value:$(draggable).attr("value")),
					//y4:"45",		
				});
				
				document.getElementById("canvas").appendChild(img);
				if($(img).attr("type") === "0") // is it an input?
					Gate.showValue(img);
					
				return img;
}

function deleteGate(g)
{
	//1- reomve lines
	//2- remove gate
	
	$(".line[gateto = '"+g.id+"']").each(function() {
				$(this).remove();
			});
	$(".line[gatefrom = '"+g.id+"']").each(function() {
				$(this).remove();
			});
			
	/*
	var line_array = $(gate).attr("line");
	line_array = line_array.split(",");
	
	for(var i = 0 ; i < line_array.length ; i++)
		$("#"+line_array[i]).remove();
		*/
	$(g).remove();
}

Gate.setValue = function(gate,value)
{
	//returns ture or false
	// true = ready to run
	// false = not ready
	value = (value == "true")? true : false;
	var gate_value = ($(gate).attr("value") == "false")? false : true;
	
	switch(parseInt($(gate).attr("type"))) // does the gate need another input?
	{

		case Gate.type.NOT:
			value = !(value); 
			$(gate).attr("value", value);
			Gate.showValue(gate);
			break;
		case Gate.type.OUTPUT:
			// needs only one input
			$(gate).attr("value", value);
			Gate.showValue(gate);
			return false;
			//break;
		case Gate.type.AND:
			if(!$(gate).attr("value"))
			{
				$(gate).attr("value", value);
				return false; // not ready
			}
			$(gate).attr("value", gate_value && value);
			Gate.showValue(gate);
			break;
		case Gate.type.OR:
			if(!$(gate).attr("value"))
			{
				$(gate).attr("value", value);
				return false; // not ready
			}
			$(gate).attr("value",  gate_value || value);
			Gate.showValue(gate);
			break;
		case Gate.type.XOR:
			if(!$(gate).attr("value"))
			{
				$(gate).attr("value", value);
				return false; // not ready
			}
			$(gate).attr("value",  (gate_value != value) );
			Gate.showValue(gate);
			break;
		case Gate.type.IMP:
			if(!$(gate).attr("value"))
			{
				$(gate).attr("value", value);
				return false; // not ready
			}
			$(gate).attr("value",  ( !gate_value || value) );
			Gate.showValue(gate);
			break;
			
			
			
		default:
			return -1;
	}
	return true;
}

Gate.switchValue = function(gate)
{
	
	$(gate).attr("value", ($(gate).attr("value") == "true")? "false" : "true"); // value = !value
	
	// redraw gate
	Gate.showValue(gate);
	
	/*
	if($(gate).attr("value") === "true")
		$(gate).attr("xlink:href", "gates/output_on.svg");
	else
		$(gate).attr("xlink:href", "gates/output_off.svg");
		
	*/
}
Gate.showValue = function(gate)
{
	if($(gate).attr("value") === "true")
		$(gate).attr("class", "gate gate_on");
	else
		$(gate).attr("class", "gate gate_off");
}

Gate.removeValue = function(gate)
{
	$(gate).attr("class", "gate");
	$(gate).attr("value", "");
}

Gate.createID = function()
{
	var id;
	while($("#gate"+(++gateCount))[0]){} // loop until finding unused id
	id = "gate"+gateCount;
	return id;
}